﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {
    public float speed;
    public float jumpSpeed;
    public Transform groundCheck;
    public Transform leftSideCheck;
    public Transform rightSideCheck;
    public LayerMask whatIsGround;
    public Transform sprite;
    public int deaths = 0;

    private bool grounded = false;
    private bool leftSide = false;
    private bool rightSide = false;
    private Transform checkpoint;
    private Vector3 start;
    private bool checkpointSet = false;
    private Animator animator;
    private bool jumpDown = false;
    private bool resetDown = false;

	// Use this for initialization
	void Start () {
        animator = sprite.GetComponent<Animator>();
        start = transform.position;
	}
	
	// Update is called once per frame
	void Update () {
        float horizontal = Input.GetAxis("Horizontal");
        if ((horizontal < 0 & leftSide == true) | (horizontal > 0 & rightSide == true))
        {
            horizontal = 0;
        }

        float vertical = rigidbody2D.velocity.y;
        if (Input.GetAxis("Jump") > 0)
        {
            if (jumpDown == false)
            {
                if (grounded == true)
                {
                    vertical = jumpSpeed;
                }
            }
            jumpDown = true;
        }
        else
        {
            jumpDown = false;
        }

        rigidbody2D.velocity = new Vector2(horizontal * speed, vertical);

        if (Input.GetAxis("Restart") > 0)
        {
            if (resetDown == false)
            {
                if (checkpointSet == true)
                {
                    restart();
                }
            }
            resetDown = true;
        }
        else
        {
            resetDown = false;
        }

        //Debug.Log(sprite.localScale.x);
        if (rigidbody2D.velocity.x > 0)
        {
            animator.SetInteger("direction", 1);
            sprite.localScale = new Vector3(1, sprite.localScale.y, sprite.localScale.z);
        }
        else if (rigidbody2D.velocity.x < 0)
        {
            animator.SetInteger("direction", -1);
            sprite.localScale = new Vector3(-1, sprite.localScale.y, sprite.localScale.z);
        }
        else
        {
            animator.SetInteger("direction", 0);
        }
    }

    void FixedUpdate()
    {
        grounded = Physics2D.OverlapArea(groundCheck.position - (groundCheck.localScale / 2), groundCheck.position + (groundCheck.localScale / 2), whatIsGround);
        animator.SetBool("jumping", !grounded);

        leftSide = Physics2D.OverlapArea(leftSideCheck.position - (leftSideCheck.localScale / 2), leftSideCheck.position + (leftSideCheck.localScale / 2), whatIsGround);
        rightSide = Physics2D.OverlapArea(rightSideCheck.position - (rightSideCheck.localScale / 2), rightSideCheck.position + (rightSideCheck.localScale / 2), whatIsGround);
    }

    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.tag == "Objective")
        {
            checkpointSet = true;
            checkpoint = other.transform;
        }
        else if (other.tag == "Harmful")
        {
            restart();
        }
    }

    private void restart()
    {
        if (checkpointSet == true)
        {
            transform.position = checkpoint.position;
        }
        else
        {
            transform.position = start;
        }
        deaths++;
    }
    
    public void resetCheckPoint()
    {
        checkpoint = null;
        checkpointSet = false;
    }
}
