﻿using UnityEngine;
using System.Collections;

public class SimpleMover : MonoBehaviour {
    public Vector2 position1;
    public Vector2 position2;
    public float speed;
    public int waitDuration;
    public int initialWait;

    private int target = 1;
    private int waitCountdown;

	// Use this for initialization
	void Start () {
        //transform.localPosition = position1;
        waitCountdown = initialWait;
	}
	
	// Update is called once per frame
	void Update () {
	}

    void FixedUpdate()
    {
        Vector2 targetPos;
        if (target == 1)
        {
            targetPos = position1;
        }
        else
        {
            targetPos = position2;
        }

        Vector2 diff = targetPos - (Vector2)transform.localPosition;
        Vector2 move = new Vector2();
        if (diff.x > 0)
        {
            move.x = Mathf.Min(diff.x, speed);
        }
        else if (diff.x < 0)
        {
            move.x = Mathf.Max(diff.x, -speed);
        }
        if (diff.y > 0)
        {
            move.y = Mathf.Min(diff.y, speed);
        }
        else if (diff.y < 0)
        {
            move.y = Mathf.Max(diff.y, -speed);
        }

        transform.localPosition = transform.localPosition + (Vector3)move;

        if ((Vector2)transform.localPosition == targetPos)
        {
            if (waitCountdown == 0)
            {
                waitCountdown = waitDuration;
                if (target == 1)
                {
                    target = 2;
                }
                else
                {
                    target = 1;
                }
            }
            else
            {
                waitCountdown--;
            }
        }
    }
}
