﻿using UnityEngine;
using System.Collections.Generic;

public class WorldCamera : MonoBehaviour {
    public float moveSpeed;
    public float scaleSpeed;
    public List<CameraPosition> positions;

    private int currentPosition = 0;

    [System.Serializable]
    public struct CameraPosition
    {
        public Vector2 position;
        public float size;
    }

	// Use this for initialization
	void Start () {
        transform.position = new Vector3(positions[0].position.x, positions[0].position.y, transform.position.z);
        camera.orthographicSize = positions[0].size;
	}
	
	// Update is called once per frame
	void Update () {
	
	}

    void FixedUpdate()
    {
        Vector2 diff = positions[currentPosition].position - (Vector2)transform.position;
        transform.position = transform.position + (Vector3)(diff * moveSpeed);

        float sizeDiff = positions[currentPosition].size - camera.orthographicSize;
        camera.orthographicSize = camera.orthographicSize + (sizeDiff * scaleSpeed);
    }

    public void nextPosition()
    {
        currentPosition++;
    }
}
